/*	inp.c	for ezomapper.win	*/
/*	1999/06/24	Rick	*/

#include	<corlib.h>

char	filename[92];
static char	title[]= "MAP Save";

static int	inpexec( WindowID, EventInfo* );
int	inpwin( WindowID, EventInfo* );


static int
inpexec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[112], *dp= dbuf;
	static	InputClass	input;

	switch( info->option ){
	case EventOpen:
		InputSet( &input, 10, 30, filename, 92, AttrDefault, 12 );
		WindowRedraw( wp );
		WindowSetEventAttr( wp, EventAttrDefault|EventUserON );
		return	TRUE;

	case EventClose:
		WindowClose( wp );
		return TRUE;

	case EventRedraw:
		DrawSetClear( dp++, 1 );
		DrawSetSymbol( dp++,   5,  5, title, AttrDefault|AttrHighLight, 16 );
		DrawSetSymbol( dp++,  70, 54, " Save ", AttrDefault, 12 );
		DrawSetSymbol( dp++, 150, 54, "Cancel", AttrDefault, 12 );
		DrawSetLine( dp++,  68, 52, 107, 67, ShadowUp, OptionShadow );
		DrawSetLine( dp++, 148, 52, 187, 67, ShadowUp, OptionShadow );
		DrawSetLine( dp++,   8, 28, 251, 43, ShadowDown, OptionShadow );
		dp+= InputSetDraw( dp, &input );
		WindowDraw( wp, dbuf, dp - dbuf );
		return	TRUE;

	case EventKey:
		WindowDraw( wp, dbuf,
					InputKey( dbuf, &input, info->KeyCode, info->ShiftStat ) );
		return TRUE;

	case EventMouseEnter:
	case EventMouseOut:
		WindowDraw( wp, dbuf,
					InputSetCursorVisible( dbuf, &input,
											info->option == EventMouseEnter ) );
		return TRUE;

	case EventUser:
		switch( info->ComData ){
		case UserPaste:
		case UserString:
			return	ClipGetKeyboardAll( wp, info );
		}
		return FALSE;
	}
	return	FALSE;
}

int
inpwin( wp, info )
WindowID	wp;
EventInfo	*info;
{
	WindowID	cwp, nwp;
	int	ret= FALSE;

	cwp= WindowSimpleOpen( 200, 200, 260, 75, NULL, inpexec );

	for(;;){
		if( !WindowGetEventInfo( info ) )	continue;

		nwp= WindowGetChild( WindowRootID, info );
		if( nwp == cwp ){
			if( info->LeftON ){
				if( info->y >52 && info->y < 67 ){
					if( info->x > 68 && info->x < 107 ){
						ret= TRUE;
						break;
					}else if( info->x >148 && info->x < 187 ){
						break;
					}
				}
			}else if( info->option == EventKey ){
				if( info->KeyCode == '\r' ){
					ret= TRUE;
					break;
				}else if( info->KeyCode == 0x1b ){
					break;
				}else {
					WindowSendEvent( nwp, info );
				}
			}else if( info->option == EventClose ){
				break;
			}else {
				WindowSendEvent( nwp, info );
			}
		}else if( nwp && nwp != wp ){
			WindowSendEvent( nwp, info );
		}
	}
	WindowClose( cwp );
	return ret;
}
