#include	<corlib.h>
#include	<iocslib.h>

#include	"ship.c"

static shipx, shipy;
static unsigned short	vtbuf[12*256*2];
static ClipClass	clip= { 0, 0, 191, 255 };
Sheet	vtram;

extern void	tput();
extern void	tclr( unsigned short* );
void	init();
void	move( WindowID );


void
init()
{
	shipx= 90;
	shipy= 240;
	vtram.h= 192;
	vtram.v= 256;
	vtram.hword= 12;
	vtram.buf1= vtbuf;
	vtram.buf2= vtbuf + 12 * 256;
}

void
move( wp )
WindowID	wp;
{
	DrawBuf	dbuf[1];
	int	stick= JOYGET( 0 );

	stick= ( ~stick ) & 15;
	if( !stick )	return;

	if( stick & 1 ){
		shipy-= 4;
		if( shipy < 0 )	shipy= 0;
	}else if( stick & 2 ){
		shipy+= 4;
		if( shipy > 240 )	shipy= 240;
	}
	if( stick & 4 ){
		shipx-= 4;
		if( shipx < 0 )	shipx= 0;
	}else if( stick & 8 ){
		shipx+= 4;
		if( shipx > 176 )	shipx= 176;
	}
	tclr( vtbuf );
	SheetCopy( &vtram, &clip, shipx, shipy, &ShipPattern );
	DrawSetPut( dbuf, 0, 0, &vtram );
	WindowDraw( wp, dbuf, 1 );
}
